=== debian/changelog ===
rocfft (5.7.1-1) unstable; urgency=medium

  * Migrate to unstable
  * New upstream version includes fix for LDS over-allocation
    (Closes: #1057251)

 -- Cordell Bloor <cgmb@slerp.xyz>  Tue, 12 Mar 2024 11:15:10 -0600

rocfft (5.7.1-1~exp2) experimental; urgency=medium

  * d/patches: Add missing DEP-3 headers
  * d/control: Re-add accidentally removed B-D libhiprand-dev.
    Fixes a FTBFS.
  * symbols: Strip Debian revision

 -- Christian Kastner <ckk@debian.org>  Sat, 02 Mar 2024 21:12:10 +0100

rocfft (5.7.1-1~exp1) experimental; urgency=medium

  * New upstream version.
    - Update symbols file
    - Refresh patches
    - Add patch use-readthedocs-theme.patch
      Restores documentation build using the simpler approach from a previous
      version
  * d/rules:
    - Add gfx1100, gfx1101 and gfx1102 build targets
    - Drop patchelf --remove-rpath from build rules
    - Automate handling of rocFFT version string
  * d/control:
    - Constrain versions for clang-17
    - Drop unused rocminfo package
    - Switch B-D from librocrand-dev to libhiprand-dev
    - Add support for the 'nocheck' build profile
    - Temporarily B-D on libamdhip64-dev >= 5.6.1
      Until either bin:hipcc is fixed or it is determined that a direct
      dependency on libamdhip64-dev is the right thing to do.
  * Upstream URL has changed
  * autopkgtest: Export dmesg and other info as artifacts
  * Bump copyrights
  * dbgsym: Disable dwz and switch to compressed DWARF-5

 -- Christian Kastner <ckk@debian.org>  Fri, 01 Mar 2024 23:23:05 +0100

rocfft (5.5.0-6) unstable; urgency=medium

  * Re-enable tests on gfx1034
    The soft lockup was apparently a faulty device.

 -- Christian Kastner <ckk@debian.org>  Fri, 10 Nov 2023 10:02:29 +0100

rocfft (5.5.0-5) unstable; urgency=medium

  [ Cordell Bloor ]
  * Fix FTBFS with Sphinx 7.1 (Closes: #1042584)

  [ Christian Kastner ]
  * Fix ftbfs-source-after-build.
    By removing the built documentation in the 'clean' target, and by
    ignoring __pycache__ directories (wherever they are). (Closes: #1049029)
  * Filter cf-protection hardening from device code
    Fixes a FTBFS with dpkg >= 1.22
  * Auto-fail tests on gfx1034 until soft lockup is resolved
  * Add myself to Uploaders

 -- Christian Kastner <ckk@debian.org>  Thu, 14 Sep 2023 11:42:37 +0200
